clc;
clear;
close all;
%********************** preparation part ***************************
para=16;    % Number of parallel channel to transmit (points)
fftlen=64;  % FFT length
%papr       % Peak-to-Average Power Ratio
nloop=1000;  % Number of simulation loops
level=4;                                        % modulation Level  : 2.4-QAM 4.16-QAM

%************************** main loop part **************************
for iii=1:nloop
    %************************** Data generation ****************************
    % Randomize bit
    X_info = randint(1,para,2^level);                        %
    seldata = qammod(X_info,2^level);                            % PSK modulation
    y=ifft(seldata);
    %*********************** Sub-block Partition ***************************
    

    M=4;
    Phase4=zeros(M,para);
    Yslm4=zeros(M,para);
    Seldata4=zeros(M,para);
    for mmm=1:M
        a=rand(1,para);
        Phase4(mmm,:)=(a<0.25)+j*(a>=0.25).*(a<0.5)-(a>=0.5).*(a<0.75)-j*(a>=0.75);
        Seldata4(mmm,:)=seldata.*Phase4(mmm,:);
        Yslm4(mmm,:)=ifft(Seldata4(mmm,:)); %  ifft : built in function
        mmam4(mmm)=max(abs(Yslm4(mmm,:)).^2);
    end
    [mmioam4,idxm4]=min(mmam4);
    P4=Phase4(idxm4,:);
    P4
    yslm4=Yslm4(idxm4,:);
    pr(iii)=papr(y);
    
    pr4(iii)=papr(yslm4);
    warning off MATLAB:divideByZero;
end
Pprr=ccdf(pr);

Pprr4=ccdf(pr4);


papr0_in_dB=2.001:0.001:14;
figure(20);
semilogy(papr0_in_dB,Pprr,'k-');
hold on;

semilogy(papr0_in_dB,Pprr4,'c-');
hold off;
axis([2 14  1e-003 1e000]) ;
ylabel('Pr(PAPR>PAPR0)');
xlabel('PAPR0/dB');
title('performance' );
legend('primary OFDM','SLM M=4');
grid on;